{1- Escriba un programa que reciba, por lnea de comandos, los datos correspondientes a un pixel (coordenadas y componentes de color RGB). Con la funcin parse_input() parsee las cadenas de entrada. Con la funcin invert_color() invierta los componentes RGB. Observe las dos posibilidades de retornar datos desde una funcin: Por su nombre o pasando una referencia del parmetro.}
{Solucin en lenguaje Pascal}

PROGRAM cap06_ej01;
{ Estructura para almacenar las coordenadas }
{ y el color RGB de un pixel. }
TYPE t_pixel = RECORD
	x, y: REAL; { Coordenadas }
	r,g,b: BYTE; { Componentes Red, Green, Blue }
	END;

{ El nuevo registro es retornado a travs del nombre de }
{ la funcin. }
FUNCTION parse_input: t_pixel;
VAR 	p: t_pixel;
	errorflag : INTEGER;
BEGIN
	{ La funcin val() intenta convertir la cadena recibida }
	{ como primer parmetro en un valor numrico. }

	VAL(PARAMSTR(1), p.x, errorflag);
	VAL(PARAMSTR(2), p.y, errorflag);

	VAL(PARAMSTR(3), p.r, errorflag);
	VAL(PARAMSTR(4), p.g, errorflag);
	VAL(PARAMSTR(5), p.b, errorflag);

	parse_input := p;
END;

{ Obsrvese el pasaje de una referencia (puntero) para }
{ modificar el parmetro dentro de la funcin. }
PROCEDURE invert_color(VAR pix: t_pixel);
BEGIN
	pix.r := 255 - pix.r;
	pix.g := 255 - pix.g;
	pix.b := 255 - pix.b;
END;
VAR pixel: t_pixel;

{ Programa Principal }
BEGIN
	IF (PARAMCOUNT <> 5) THEN
		BEGIN
			WRITELN('Modo de uso: ', PARAMSTR(0), ' <x> <y> <r> <g> <b>');
			EXIT;
		END;

	pixel := parse_input();

	WRITELN(' Coord pixel: ( ', pixel.x:6:2, ' , ', pixel.y:6:2, ' )');
	WRITELN(' RGB: ( ', pixel.r, ' , ', pixel.g, ' , ', pixel.b, ' )');

	{ El color RGB es invertido }
	invert_color(pixel);

	WRITELN(' RGB invert: ( ', pixel.r, ' , ', pixel.g, ' , ', pixel.b, ' )');
END.