/* 3- En una empresa de turismo se desea saber cul es el pas ms visitado por sus clientes. Para ello se cuenta con una tabla de destinos y la cantidad de veces que fueron visitados. Se implementan funciones para la carga de datos y la bsqueda de mximo (que es secuencial). Cree el algoritmo necesario para tal fin. Utilice y observe la lectura de cadenas de caracteres mediante la funcin fgets(), ms segura que scanf(). Tambin haga la limpieza del buffer de teclado. */
/* Solucin en lenguaje C

#include <stdio.h>
#include <string.h>

#define MAX_DESTINOS 100

/* Tipo registro para almacenar un destino */
typedef struct {
	char pais[30];
	char medio[30];
	int cant_veces;
	} t_destino;

/* Lista de destinos */
typedef t_destino t_vector[MAX_DESTINOS];

/* Prototipos */
void cargar_datos(t_vector, int);
t_destino buscar_mas_visitado(t_vector, int);

/* Programa Principal */
int main()
{
	t_vector lista_destinos;
	int cant_destinos;
	t_destino destino;

	printf("EMPRESA DE TURISMO\n");
	printf("~~~~~~~~~~~~~~~~~~\n\n");

	printf("Ingrese la cantidad de destinos (pases) a cargar: ");
	scanf("%d",&cant_destinos);
	while (getchar() != '\n'); /* Limpieza buffer de teclado */

	cargar_datos(lista_destinos, cant_destinos);
	destino = buscar_mas_visitado(lista_destinos, cant_destinos);

	printf("Pas ms visitado es: %s\n", destino.pais);
	printf("Medio de transporte es: %s\n", destino.medio);
	printf("Cantidad de visitas es: %d\n", destino.cant_veces);
	return 0;
}
void cargar_datos(t_vector lista_destinos, int n)
{
	int i;
	for (i=0; i<n; i++)
	{
		printf("Ingrese el pas: ");
		fgets(lista_destinos[i].pais, 30, stdin);
		if (lista_destinos[i].pais[strlen(lista_destinos[i].pais)-1] == '\n') lista_destinos[i].pais[strlen(lista_destinos[i].pais)-1] = '\0';
		else
		while (getchar() != '\n'); /* Limpieza buffer de teclado */

		printf("Ingrese el medio de transporte: ");
		fgets(lista_destinos[i].medio, 30, stdin);
		if (lista_destinos[i].medio[strlen(lista_destinos[i].medio)-1] == '\n') lista_destinos[i].medio[strlen(lista_destinos[i].medio)-1] = '\0';
		else
		while (getchar() != '\n'); /* Limpieza buffer de teclado */
		printf("Ingrese la cantidad de veces que eligieron este destino: ");
		scanf("%d", &(lista_destinos[i].cant_veces));
		while (getchar() != '\n'); /* Limpieza buffer de teclado */
	}
}

/* El registro cargado es retornado por el nombre de la funcin */
t_destino buscar_mas_visitado(t_vector lista_destinos, int n)
{
	int i, pos = 0;
	int mayor = lista_destinos[0].cant_veces;
	for (i=1; i<n; i++)
		if (lista_destinos[i].cant_veces > mayor)
		{
		mayor = lista_destinos[i].cant_veces;
		pos = i;
		}
	return lista_destinos[pos];
}