/* 2- Utilice registros jerrquicos para cargar datos relativos a un alumno y calcular el promedio de sus notas. Utilice la funcin fgets() y la limpieza del buffer de teclado. */
/* Solucin en lenguaje C */

#include <stdio.h>
#include <string.h>

#define MAX_NOMBRE 51
#define MAX_MATERIAS 30

typedef struct {
	int dia, mes, anio;
	} t_fecha;

typedef struct {
	long cod_materia;
	float nota;
	t_fecha fecha_aprob;
	} t_materia;

typedef struct {
	long padron;
	char nombre[MAX_NOMBRE];
	t_materia materias[MAX_MATERIAS];
	} t_alumno;

float promedio(t_materia[]);

int main()
{
	t_alumno alumno;
	int i;
	printf("Ingrese los datos del alumno:\n\n");

	printf("Padrn: ");
	scanf("%ld", &alumno.padron);
	while (getchar() != '\n'); /* Limpieza buffer de teclado */

	printf("Nombre y apellido (mx %d caracteres): ", MAX_NOMBRE-1);
	fgets(alumno.nombre, MAX_NOMBRE, stdin);
	if (alumno.nombre[strlen(alumno.nombre)-1] == '\n')
		alumno.nombre[strlen(alumno.nombre)-1] = '\0';
	else
		while (getchar() != '\n'); /* Limpieza buffer de teclado */
	for (i=0; i<MAX_MATERIAS; i++)
	{
		printf("\tCd materia: ");
		scanf("%ld", &alumno.materias[i].cod_materia);
		while (getchar() != '\n'); /* Limpieza buffer de teclado */

		printf("\tNota: ");
		scanf("%f", &alumno.materias[i].nota);
		while (getchar() != '\n'); /* Limpieza buffer de teclado */

		printf("\tFecha aprobacin (DD MM AAAA): ");
		scanf("%d %d %d", &alumno.materias[i].fecha_aprob.dia,&alumno.materias[i].fecha_aprob.mes,&alumno.materias[i].fecha_aprob.anio );
		while (getchar() != '\n'); /* Limpieza buffer de teclado */
		printf("\n");
	}

	printf("PROMEDIO DE NOTAS: %.2f\n\n", promedio(alumno.materias));
	return 0;
}
float promedio(t_materia materias[])
{
	int i;
	float suma = 0.0;

	for (i=0; i<MAX_MATERIAS; i++)
		suma += materias[i].nota;
		return (suma / MAX_MATERIAS);
}