{2- Utilice registros jerrquicos para cargar datos relativos a un alumno y calcular el promedio de sus notas. Utilice la funcin fgets() y la limpieza del buffer de teclado.}
{Solucin en lenguaje Pascal}

PROGRAM cap06_ej02;

CONST 	MAX_NOMBRE = 50;
	MAX_MATERIAS = 30;

TYPE 	t_fecha = RECORD
	dia, mes, anio: INTEGER;
	END;

TYPE 	t_materia = RECORD
	cod_materia: LONGINT;
	nota: REAL;
	fecha_aprob: t_fecha;
	END;

TYPE 	t_materias = ARRAY[1..MAX_MATERIAS] OF t_materia;
TYPE 	t_alumno = RECORD
	padron: LONGINT;
	nombre: STRING[MAX_NOMBRE];
	materias: t_materias;
	END;

FUNCTION promedio(materias: t_materias): REAL;

VAR 	i: INTEGER;
	suma: REAL;

BEGIN
	suma := 0.0;
	FOR i:=1 TO MAX_MATERIAS DO
		suma := suma + materias[i].nota;

	promedio := suma / MAX_MATERIAS;
END;

VAR 	alumno: t_alumno;
	i: INTEGER;

{Programa Principal}
BEGIN
	WRITELN('Ingrese los datos del alumno:');
	WRITELN;
	WRITE('Padrn: ');
	READLN(alumno.padron);
	WRITE('Nombre y apellido (mx ', MAX_NOMBRE, ' caracteres): ');
	READLN(alumno.nombre);
	FOR i:=1 TO MAX_MATERIAS DO
		BEGIN		
			WRITE(' Cd materia: ');
			READLN(alumno.materias[i].cod_materia);
			WRITE(' Nota: ');
			READLN(alumno.materias[i].nota);
			WRITE(' Fecha aprobacin (DD MM AAAA): ');
			READLN(alumno.materias[i].fecha_aprob.dia,alumno.materias[i].fecha_aprob.mes,alumno.materias[i].fecha_aprob.anio);
			WRITELN;
		END;
	WRITELN('PROMEDIO DE NOTAS: ',promedio(alumno.materias):4:2);
END.