{3- En una empresa de turismo se desea saber cul es el pas ms visitado por sus clientes. Para ello se cuenta con una tabla de destinos y la cantidad de veces que fueron visitados. Se implementan funciones para la carga de datos y la bsqueda de mximo (que es secuencial). Cree el algoritmo necesario para tal fin. Utilice y observe la lectura de cadenas de caracteres mediante la funcin fgets(), ms segura que scanf(). Tambin haga la limpieza del buffer de teclado.}
{Solucin en lenguaje Pascal}

PROGRAM cap06_ej03;

CONST MAX_DESTINOS = 100;
{ Tipo registro para almacenar un destino }
TYPE 	t_destino = RECORD
	pais: STRING[30];
	medio: STRING[30];
	cant_veces: INTEGER;
	END;

{ Lista de destinos }
TYPE t_vector = ARRAY[1..MAX_DESTINOS] OF t_destino;

PROCEDURE cargar_datos(VAR lista_destinos: t_vector; n: INTEGER);

VAR i: INTEGER;

BEGIN
	FOR i:=1 TO n DO
	BEGIN
		WRITE('Ingrese el pas: ');
		READLN(lista_destinos[i].pais);
		WRITE('Ingrese el medio de transporte: ');
		READLN(lista_destinos[i].medio);
		WRITE('Ingrese la cantidad de veces que eligieron este destino: ');
		READLN(lista_destinos[i].cant_veces);
	END;
END;

{ El registro cargado es retornado por el nombre de la funcin }
FUNCTION buscar_mas_visitado(lista_destinos: t_vector; n: INTEGER): t_destino;

VAR i, pos, mayor: INTEGER;

BEGIN
	pos := 1;
	mayor := lista_destinos[1].cant_veces;

	FOR i:=2 TO n DO
		IF (lista_destinos[i].cant_veces > mayor) THEN
		BEGIN
		mayor := lista_destinos[i].cant_veces;
		pos := i;
		END;
	buscar_mas_visitado := lista_destinos[pos];
END;

VAR 	lista_destinos: t_vector;
	cant_destinos: INTEGER;
	destino: t_destino;

{ Programa Principal }
BEGIN

	WRITELN('EMPRESA DE TURISMO');
	WRITELN('~~~~~~~~~~~~~~~~~~');
	WRITELN;

	WRITE('Ingrese la cantidad de destinos (pases) a cargar: ');
	READLN(cant_destinos);

	cargar_datos(lista_destinos, cant_destinos);
	destino := buscar_mas_visitado(lista_destinos, cant_destinos);

	WRITELN('Pas ms visitado es: ', destino.pais);
	WRITELN('Medio de transporte es: ', destino.medio);
	WRITELN('Cantidad de visitas es: ', destino.cant_veces);
END.