{5- Inicialice un tablero para el juego de la batalla naval. El tablero es una matriz bidimensional, donde cada casillero es un registro. La inicializacin debera hacerse en forma aleatoria (tarea para el lector).}
{Solucin en lenguaje Pascal}

PROGRAM cap06_ej05;

CONST COLS = 20;
CONST FILAS = 10;

TYPE 	t_tipo = (ACORAZADO, CRUCERO, PORTAAVIONES);

TYPE 	t_casillero = RECORD
	ocupado: BOOLEAN;
	tipo: t_tipo;
	hundido: BOOLEAN;
	END;

TYPE t_tablero = ARRAY[1..FILAS, 1..COLS] OF t_casillero;
PROCEDURE inicializar_tablero(VAR tablero: t_tablero);

VAR i,j: INTEGER;
BEGIN
	FOR i:=1 TO FILAS DO
		FOR j:=1 TO COLS DO
			tablero[i,j].ocupado := FALSE;
		{ 1 acorazado }
		tablero[4,18].ocupado := TRUE;
		tablero[4,18].tipo := ACORAZADO;
		tablero[4,18].hundido := FALSE;
		tablero[5,18].ocupado := TRUE;
		tablero[5,18].tipo := ACORAZADO;
		tablero[5,18].hundido := FALSE;
		tablero[6,18].ocupado := TRUE;
		tablero[6,18].tipo := ACORAZADO;
		tablero[6,18].hundido := FALSE;

		{ 2 cruceros }
		tablero[9,2].ocupado := TRUE;
		tablero[9,2].tipo := CRUCERO;
		tablero[9,2].hundido := FALSE;
		tablero[9,3].ocupado := TRUE;
		tablero[9,3].tipo := CRUCERO;
		tablero[9,3].hundido := FALSE;
		tablero[3,9].ocupado := TRUE;
		tablero[3,9].tipo := CRUCERO;
		tablero[3,9].hundido := FALSE;
		tablero[4,9].ocupado := TRUE;
		tablero[4,9].tipo := CRUCERO;
		tablero[4,9].hundido := FALSE;

		{ 3 portaaviones }
		tablero[1,1].ocupado := TRUE;
		tablero[1,1].tipo := PORTAAVIONES;
		tablero[1,1].hundido := FALSE;
		tablero[6,12].ocupado := TRUE;
		tablero[6,12].tipo := PORTAAVIONES;
		tablero[6,12].hundido := FALSE;
		tablero[8,19].ocupado := TRUE;
		tablero[8,19].tipo := PORTAAVIONES;
		tablero[8,19].hundido := FALSE;
	END;
	PROCEDURE mostrar_tablero(tablero: t_tablero);

	VAR i,j: INTEGER;
	BEGIN
		WRITE(' ');
		FOR i:=1 TO COLS+2 DO
			WRITE('-');
		WRITELN;
		FOR i:=1 TO FILAS DO
			BEGIN

			WRITE(' |');
			FOR j:=1 TO COLS DO
				BEGIN
					IF (NOT tablero[i,j].ocupado) THEN
					WRITE(' ')
					ELSE
					CASE (tablero[i,j].tipo) OF
					ACORAZADO: WRITE('#');
					CRUCERO: WRITE('X');
					PORTAAVIONES: WRITE('@');
				END;
			END;
		WRITELN('|');
	END;

	WRITE(' ');
	FOR i:=1 TO COLS+2 DO
		WRITE('-');
	WRITELN;
	END;	

VAR tablero: t_tablero;

{ Programa Principal }
BEGIN

	inicializar_tablero(tablero);
	mostrar_tablero(tablero);
END.